"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
exports.UserFlowMock = exports.Ufo = void 0;
const tslib_1 = require("tslib");
const loggin_1 = require("../core/loggin");
/**
 * This class is used in the user-flow interactions to ensure the context of the flow is available in UFO's
 */
class Ufo {
    constructor({ page }) {
        this.page = page;
    }
}
exports.Ufo = Ufo;
;
/**
 * @TODO this is very flakey ATM and needs investigation
 */
class UserFlowMock {
    constructor(page, { name }) {
        this.page = page;
    }
    /**
     * @param {LH.NavigationRequestor} requestor
     * @param {StepOptions=} stepOptions
     */
    navigate(requestor, { stepName } = {}) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#navigate: ${stepName || requestor}`);
            return this.page.goto(requestor);
        });
    }
    /**
     * @param {StepOptions=} stepOptions
     */
    startTimespan({ stepName } = {}) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#startTimespan: ${stepName}`);
            return Promise.resolve();
        });
    }
    endTimespan({ stepName } = {}) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#endTimespan: ${stepName}`);
            return Promise.resolve();
        });
    }
    /**
     * @param {StepOptions=} stepOptions
     */
    snapshot({ stepName } = {}) {
        return (0, tslib_1.__awaiter)(this, void 0, void 0, function* () {
            (0, loggin_1.logVerbose)(`flow#snapshot: ${stepName}`);
            return Promise.resolve();
        });
    }
    /**
     * @return {LH.FlowResult}
     */
    getFlowResult() {
        (0, loggin_1.logVerbose)(`flow#getFlowResult`);
        return {};
    }
    /**
     * @return {Promise<string>}
     */
    generateReport() {
        (0, loggin_1.logVerbose)(`flow#generateReport`);
        return Promise.resolve('');
    }
}
exports.UserFlowMock = UserFlowMock;
//# sourceMappingURL=model.js.map